=== debian/changelog ===
neovim-gitsigns (1.0.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1114724)

 -- Carl Keinath <carl.keinath@gmail.com>  Sun, 14 Sep 2025 10:01:20 +0200
