=== debian/control ===
Source: neovim-gitsigns
Section: editors
Priority: optional
Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
Uploaders: Carl Keinath <carl.keinath@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-vim-addon,
Standards-Version: 4.7.2
Homepage: https://github.com/lewis6991/gitsigns.nvim
Vcs-Browser: https://salsa.debian.org/vim-team/neovim-gitsigns
Vcs-Git: https://salsa.debian.org/vim-team/neovim-gitsigns.git

Package: neovim-gitsigns
Architecture: all
Depends:
 ${misc:Depends},
 ${vim-addon:Depends},
 git,
Description: Git integration for buffers in Neovim
 gitsigns.nvim is a Lua plugin for Neovim that shows Git status
 directly in buffers. It displays signs for added, changed and
 deleted lines.
 .
 This is a neovim-only plugin.
