=== debian/watch ===
Version: 5

Template: Github
Owner: lewis6991
Project: gitsigns.nvim
