=== debian/changelog ===
neovim-gitsigns (2.0.0-1) unstable; urgency=medium

  * New upstream release
  * bump Standards-Version to 4.7.3

 -- Carl Keinath <carl.keinath@gmail.com>  Sat, 10 Jan 2026 21:21:35 +0100
