=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: neovim-gitsigns
 Section: editors
-Priority: optional
 Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
 Uploaders: Carl Keinath <carl.keinath@gmail.com>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-vim-addon,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/lewis6991/gitsigns.nvim
 Vcs-Browser: https://salsa.debian.org/vim-team/neovim-gitsigns
 Vcs-Git: https://salsa.debian.org/vim-team/neovim-gitsigns.git
